{diese Unit enthlt das Eintrag-Bearbeiten-Formular}
unit Edit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Address;
{           ^^^^^^^
da hier die Klasse TAddress aus der Unit Address bereits bei der Definition
der EditForm-Klasse bentigt wird (also im Interface-Teil der Unit), mu
unsere Address-Unit bereits hier oben eingebunden werden, ansonsten htte es
gengt, sie nach dem Schlsselwort Implementation einzubinden (siehe Unit Main)}

type
{die zum Formular gehrige Klasse}
  TEditForm = class(TForm)
{die einzelnen Steuerelemente}
    NameEdit: TEdit;
    FirstnameEdit: TEdit;
    AddressMemo: TMemo;
    OkButton: TButton;
    CancelButton: TButton;
    NameLabel: TLabel;
    FirstnameLabel: TLabel;
    AddressLabel: TLabel;
  private
    { Private-Deklarationen}
  public
{die Funktionen, welche vom Hauptformular aus aufgerufen werden knnen sollen}
    function Edit(aAddress:TAddress):TModalResult; {Eintrag bearbeiten}
    function Add:TModalResult; {Eintrag hinzufgen}
    function getAddress:TAddress; {den eingetragene Addresseintrag zurckgeben}
  end;

var
{Variable fr das Editfenster, da diese Unit in der Unit Main eingebunden wurde
(uses ...,Edit,...;) kann diese Variable im Hauptformular verwendet werden}
  EditForm: TEditForm;

implementation

{$R *.DFM}

{wird aufgerufen, wenn ein Entrag bearbeitet werden soll
Rckgabe: TModalResult, zeigt an wie das Edit-Formular geschlossen wurde:
diese Werte knnen direkt mit Knpfen (im Objektinspektor,
Eigenschaft ModalResult) verknpft werden, dadurch wird eine extra Behandlung
des Ok-Knopf-gedrck-Ereignisses unntig}
function TEditForm.Edit(aAddress:TAddress):TModalResult;
begin
{die Eingabe-Felder des Edit-Fensters mit der Vorgabe fllen}
  NameEdit.Text:=aAddress.getName;
  FirstnameEdit.Text:=aAddress.getFirstname;
  AddressMemo.Text:=aAddress.getAddress;
{das am Anfang aktive Element soll die Nachnamenseingabe sein}
  ActiveControl:=NameEdit;
{zeigt das Editfenster als sogenanntes modales Fenster an. D.H. die Ausfhrung
des Programms wird unterbrochen und erst weitergefhrt, wenn das modale Fenster
geschlossen wurde, ShowModal liefert gnstiger weise ein TModalResult-Wert zurck}
  Edit:=ShowModal;
end;

{soll zum Eintrag-Hinzufgen aufgerufen werden}
function TEditForm.Add:TModalResult;
begin
{den Inhalt der Eingabe-Felder lschen}
  NameEdit.Text:='';
  FirstnameEdit.Text:='';
  AddressMemo.Text:='';
{aktives Steuerelement soll wieder die Nachnamenseingabe sein}
  ActiveControl:=NameEdit;
{das Fenster 'modal' anzeigen, siehe oben bei TEditForm.Edit}
  Add:=ShowModal;
end;

{erzeugt einen Address-Eintrag (als Instanz von TAddress (siehe Unit Address)
und setzt dessen Felder auf die eingegebenen Zeichenketten}
function TEditForm.getAddress:TAddress;
var Address:TAddress;
begin
  Address:=TAddress.Create; {Instanz erzeugen}
  Address.setName(NameEdit.Text); {Nachnamen setzen}
  Address.setFirstname(FirstnameEdit.Text); {Vornamen setzen}
  Address.setAddress(AddressMemo.Text); {Address-String setzen}
  getAddress:=Address; {Referenz zurckgeben}
end;

end.
